/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_LOGIN = 258,
     TOK_LOGOUT = 259,
     TOK_STATUS = 260,
     TOK_STATUS_ALL = 261,
     TOK_STATUS_SOFT = 262,
     TOK_STATUS_SOFT_ALL = 263,
     TOK_STATUS_TEMP = 264,
     TOK_STATUS_TEMP_ALL = 265,
     TOK_STATUS_BEACON = 266,
     TOK_STATUS_BEACON_ALL = 267,
     TOK_BEACON_ON = 268,
     TOK_BEACON_OFF = 269,
     TOK_ON = 270,
     TOK_ON_ALL = 271,
     TOK_OFF = 272,
     TOK_OFF_ALL = 273,
     TOK_CYCLE = 274,
     TOK_CYCLE_ALL = 275,
     TOK_RESET = 276,
     TOK_RESET_ALL = 277,
     TOK_PING = 278,
     TOK_SPEC = 279,
     TOK_EXPECT = 280,
     TOK_SETPLUGSTATE = 281,
     TOK_SEND = 282,
     TOK_DELAY = 283,
     TOK_FOREACHPLUG = 284,
     TOK_FOREACHNODE = 285,
     TOK_IFOFF = 286,
     TOK_IFON = 287,
     TOK_OFF_STRING = 288,
     TOK_ON_STRING = 289,
     TOK_MAX_PLUG_COUNT = 290,
     TOK_TIMEOUT = 291,
     TOK_DEV_TIMEOUT = 292,
     TOK_PING_PERIOD = 293,
     TOK_PLUG_NAME = 294,
     TOK_SCRIPT = 295,
     TOK_DEVICE = 296,
     TOK_NODE = 297,
     TOK_ALIAS = 298,
     TOK_TCP_WRAPPERS = 299,
     TOK_PORT = 300,
     TOK_MATCHPOS = 301,
     TOK_STRING_VAL = 302,
     TOK_NUMERIC_VAL = 303,
     TOK_YES = 304,
     TOK_NO = 305,
     TOK_BEGIN = 306,
     TOK_END = 307,
     TOK_UNRECOGNIZED = 308,
     TOK_EQUALS = 309,
     TOK_B_NODES = 310,
     TOK_E_NODES = 311,
     TOK_B_GLOBAL = 312,
     TOK_E_GLOBAL = 313,
     TOK_OLD_PORT = 314
   };
#endif
#define TOK_LOGIN 258
#define TOK_LOGOUT 259
#define TOK_STATUS 260
#define TOK_STATUS_ALL 261
#define TOK_STATUS_SOFT 262
#define TOK_STATUS_SOFT_ALL 263
#define TOK_STATUS_TEMP 264
#define TOK_STATUS_TEMP_ALL 265
#define TOK_STATUS_BEACON 266
#define TOK_STATUS_BEACON_ALL 267
#define TOK_BEACON_ON 268
#define TOK_BEACON_OFF 269
#define TOK_ON 270
#define TOK_ON_ALL 271
#define TOK_OFF 272
#define TOK_OFF_ALL 273
#define TOK_CYCLE 274
#define TOK_CYCLE_ALL 275
#define TOK_RESET 276
#define TOK_RESET_ALL 277
#define TOK_PING 278
#define TOK_SPEC 279
#define TOK_EXPECT 280
#define TOK_SETPLUGSTATE 281
#define TOK_SEND 282
#define TOK_DELAY 283
#define TOK_FOREACHPLUG 284
#define TOK_FOREACHNODE 285
#define TOK_IFOFF 286
#define TOK_IFON 287
#define TOK_OFF_STRING 288
#define TOK_ON_STRING 289
#define TOK_MAX_PLUG_COUNT 290
#define TOK_TIMEOUT 291
#define TOK_DEV_TIMEOUT 292
#define TOK_PING_PERIOD 293
#define TOK_PLUG_NAME 294
#define TOK_SCRIPT 295
#define TOK_DEVICE 296
#define TOK_NODE 297
#define TOK_ALIAS 298
#define TOK_TCP_WRAPPERS 299
#define TOK_PORT 300
#define TOK_MATCHPOS 301
#define TOK_STRING_VAL 302
#define TOK_NUMERIC_VAL 303
#define TOK_YES 304
#define TOK_NO 305
#define TOK_BEGIN 306
#define TOK_END 307
#define TOK_UNRECOGNIZED 308
#define TOK_EQUALS 309
#define TOK_B_NODES 310
#define TOK_E_NODES 311
#define TOK_B_GLOBAL 312
#define TOK_E_GLOBAL 313
#define TOK_OLD_PORT 314




/* Copy the first part of user declarations.  */
#line 27 "parse.y"


#define YYSTYPE char *  /*  The generic type returned by all parse matches */
#undef YYDEBUG          /* no debug code plese */
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>       /* for HUGE_VAL and trunc */
#include <assert.h>
#include <stdio.h>
#include <ctype.h>
#include <unistd.h>

#include "powerman.h"
#include "list.h"
#include "parse_util.h"
#include "wrappers.h"
#include "pluglist.h"
#include "device.h"
#include "device_serial.h"
#include "device_pipe.h"
#include "device_tcp.h"
#include "error.h"
#include "string.h"

/*
 * A PreScript is a list of PreStmts.
 */
#define PRESTMT_MAGIC 0x89786756
typedef struct {
    int magic;
    StmtType type;              /* delay/expect/send */
    char *str;                  /* expect string, send fmt, setplugstate plug */
    struct timeval tv;          /* delay value */
    int mp1;                    /* setplugstate plug match position */
    int mp2;                    /* setplugstate state match position */
    List prestmts;              /* subblock */
    List interps;               /* interpretations for setplugstate */
} PreStmt;
typedef List PreScript;

/*
 * Unprocessed Protocol (used during parsing).
 * This data will be copied for each instantiation of a device.
 */
typedef struct {
    char *name;                 /* specification name, e.g. "icebox" */
    struct timeval timeout;     /* timeout for this device */
    struct timeval ping_period; /* ping period for this device 0.0 = none */
    List plugs;                 /* list of plug names (e.g. "1" thru "10") */
    PreScript prescripts[NUM_SCRIPTS];  /* array of PreScripts */
} Spec;                                 /*   script may be NULL if undefined */

/* powerman.conf */
static void makeNode(char *nodestr, char *devstr, char *plugstr);
static void makeAlias(char *namestr, char *hostsstr);
static Stmt *makeStmt(PreStmt *p);
static void destroyStmt(Stmt *stmt);
static void makeDevice(char *devstr, char *specstr, char *hoststr, 
                        char *portstr);
static void makeClientPort(char *s2);

/* device config */
static PreStmt *makePreStmt(StmtType type, char *str, char *tvstr, 
                      char *mp1str, char *mp2str, List prestmts, List interps);
static void destroyPreStmt(PreStmt *p);
static Spec *makeSpec(char *name);
static Spec *findSpec(char *name);
static int matchSpec(Spec * spec, void *key);
static void destroySpec(Spec * spec);
static void _clear_current_spec(void);
static void makeScript(int com, List stmts);
static void destroyInterp(Interp *i);
static Interp *makeInterp(InterpState state, char *str);
static List copyInterpList(List ilist);

/* utility functions */
static void _errormsg(char *msg);
static void _warnmsg(char *msg);
static long _strtolong(char *str);
static double _strtodouble(char *str);
static void _doubletotv(struct timeval *tv, double val);

extern int yylex();
void yyerror();


static List device_specs = NULL;      /* list of Spec's */
static Spec current_spec;             /* Holds a Spec as it is built */


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 297 "parse_tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   145

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  60
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  26
/* YYNRULES -- Number of rules. */
#define YYNRULES  82
/* YYNRULES -- Number of states. */
#define YYNSTATES  141

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   314

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     6,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    36,    39,    42,
      45,    51,    56,    61,    65,    69,    72,    74,    80,    83,
      85,    87,    89,    91,    93,    96,    99,   102,   104,   109,
     112,   114,   118,   122,   126,   130,   134,   138,   142,   146,
     150,   154,   158,   162,   166,   170,   174,   178,   182,   186,
     190,   194,   198,   202,   205,   207,   210,   213,   216,   220,
     225,   229,   234,   237,   241,   244,   247,   250,   253,   256,
     258,   262,   266
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      61,     0,    -1,    70,    62,    -1,    62,    63,    -1,    63,
      -1,    66,    -1,    65,    -1,    67,    -1,    68,    -1,    69,
      -1,    64,    -1,    55,    -1,    56,    -1,    57,    -1,    58,
      -1,    44,    -1,    44,    49,    -1,    44,    50,    -1,    45,
      48,    -1,    59,    48,    -1,    41,    47,    47,    47,    47,
      -1,    41,    47,    47,    47,    -1,    42,    47,    47,    47,
      -1,    42,    47,    47,    -1,    43,    47,    47,    -1,    70,
      71,    -1,    71,    -1,    24,    47,    51,    72,    52,    -1,
      72,    73,    -1,    73,    -1,    74,    -1,    75,    -1,    77,
      -1,    78,    -1,    37,    48,    -1,    38,    48,    -1,    76,
      47,    -1,    47,    -1,    39,    51,    76,    52,    -1,    78,
      79,    -1,    79,    -1,    40,     3,    80,    -1,    40,     4,
      80,    -1,    40,     5,    80,    -1,    40,     6,    80,    -1,
      40,     7,    80,    -1,    40,     8,    80,    -1,    40,     9,
      80,    -1,    40,    10,    80,    -1,    40,    11,    80,    -1,
      40,    12,    80,    -1,    40,    13,    80,    -1,    40,    14,
      80,    -1,    40,    15,    80,    -1,    40,    16,    80,    -1,
      40,    17,    80,    -1,    40,    18,    80,    -1,    40,    19,
      80,    -1,    40,    20,    80,    -1,    40,    21,    80,    -1,
      40,    22,    80,    -1,    40,    23,    80,    -1,    51,    81,
      52,    -1,    81,    82,    -1,    82,    -1,    25,    47,    -1,
      27,    47,    -1,    28,    48,    -1,    26,    47,    85,    -1,
      26,    47,    85,    83,    -1,    26,    85,    85,    -1,    26,
      85,    85,    83,    -1,    26,    85,    -1,    26,    85,    83,
      -1,    30,    80,    -1,    29,    80,    -1,    31,    80,    -1,
      32,    80,    -1,    83,    84,    -1,    84,    -1,    15,    54,
      47,    -1,    17,    54,    47,    -1,    46,    48,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   148,   148,   154,   155,   157,   158,   159,   160,   161,
     162,   164,   166,   168,   170,   174,   177,   179,   183,   185,
     190,   193,   197,   199,   203,   210,   211,   213,   219,   220,
     222,   223,   224,   225,   227,   231,   235,   238,   243,   249,
     250,   252,   254,   256,   258,   260,   262,   264,   266,   268,
     270,   272,   274,   276,   278,   280,   282,   284,   286,   288,
     290,   292,   296,   300,   303,   308,   310,   312,   314,   316,
     319,   321,   323,   325,   327,   330,   333,   336,   341,   344,
     349,   351,   355
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_LOGIN", "TOK_LOGOUT", "TOK_STATUS",
  "TOK_STATUS_ALL", "TOK_STATUS_SOFT", "TOK_STATUS_SOFT_ALL",
  "TOK_STATUS_TEMP", "TOK_STATUS_TEMP_ALL", "TOK_STATUS_BEACON",
  "TOK_STATUS_BEACON_ALL", "TOK_BEACON_ON", "TOK_BEACON_OFF", "TOK_ON",
  "TOK_ON_ALL", "TOK_OFF", "TOK_OFF_ALL", "TOK_CYCLE", "TOK_CYCLE_ALL",
  "TOK_RESET", "TOK_RESET_ALL", "TOK_PING", "TOK_SPEC", "TOK_EXPECT",
  "TOK_SETPLUGSTATE", "TOK_SEND", "TOK_DELAY", "TOK_FOREACHPLUG",
  "TOK_FOREACHNODE", "TOK_IFOFF", "TOK_IFON", "TOK_OFF_STRING",
  "TOK_ON_STRING", "TOK_MAX_PLUG_COUNT", "TOK_TIMEOUT", "TOK_DEV_TIMEOUT",
  "TOK_PING_PERIOD", "TOK_PLUG_NAME", "TOK_SCRIPT", "TOK_DEVICE",
  "TOK_NODE", "TOK_ALIAS", "TOK_TCP_WRAPPERS", "TOK_PORT", "TOK_MATCHPOS",
  "TOK_STRING_VAL", "TOK_NUMERIC_VAL", "TOK_YES", "TOK_NO", "TOK_BEGIN",
  "TOK_END", "TOK_UNRECOGNIZED", "TOK_EQUALS", "TOK_B_NODES",
  "TOK_E_NODES", "TOK_B_GLOBAL", "TOK_E_GLOBAL", "TOK_OLD_PORT", "$accept",
  "configuration_file", "config_list", "config_item", "deprecated",
  "TCP_wrappers", "client_port", "device", "node", "alias", "spec_list",
  "spec", "spec_item_list", "spec_item", "spec_timeout",
  "spec_ping_period", "string_list", "spec_plug_list", "spec_script_list",
  "spec_script", "stmt_block", "stmt_list", "stmt", "interp_list",
  "interp", "regmatch", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    60,    61,    62,    62,    63,    63,    63,    63,    63,
      63,    64,    64,    64,    64,    65,    65,    65,    66,    66,
      67,    67,    68,    68,    69,    70,    70,    71,    72,    72,
      73,    73,    73,    73,    74,    75,    76,    76,    77,    78,
      78,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      79,    79,    80,    81,    81,    82,    82,    82,    82,    82,
      82,    82,    82,    82,    82,    82,    82,    82,    83,    83,
      84,    84,    85
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       5,     4,     4,     3,     3,     2,     1,     5,     2,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     4,     2,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     1,     2,     2,     2,     3,     4,
       3,     4,     2,     3,     2,     2,     2,     2,     2,     1,
       3,     3,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,    26,     0,     1,     0,     0,     0,
      15,     0,    11,    12,    13,    14,     0,     2,     4,    10,
       6,     5,     7,     8,     9,    25,     0,     0,     0,     0,
      16,    17,    18,    19,     3,     0,     0,     0,     0,     0,
      29,    30,    31,    32,    33,    40,     0,    23,    24,    34,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,    28,    39,    21,    22,    37,     0,
       0,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    20,    36,    38,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    64,    65,     0,     0,    72,    66,
      67,    75,    74,    76,    77,    62,    63,    82,    68,     0,
       0,    73,    79,    70,    69,     0,     0,    78,    71,    80,
      81
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,    17,    18,    19,    20,    21,    22,    23,    24,
       3,     4,    39,    40,    41,    42,    79,    43,    44,    45,
      81,   113,   114,   131,   132,   118
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -107
static const yysigned_char yypact[] =
{
      26,    56,   112,    -4,  -107,    62,  -107,    68,    69,    70,
     -23,    66,  -107,  -107,  -107,  -107,    71,    50,  -107,  -107,
    -107,  -107,  -107,  -107,  -107,  -107,    60,    73,    74,    75,
    -107,  -107,  -107,  -107,  -107,    76,    77,    72,    67,   -16,
    -107,  -107,  -107,  -107,    78,  -107,    79,    80,  -107,  -107,
    -107,    81,    82,    82,    82,    82,    82,    82,    82,    82,
      82,    82,    82,    82,    82,    82,    82,    82,    82,    82,
      82,    82,    82,  -107,  -107,  -107,    83,  -107,  -107,   -17,
      36,  -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,
    -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,
    -107,  -107,  -107,  -107,  -107,    84,   -13,    85,    86,    82,
      82,    82,    82,    17,  -107,  -107,    88,    89,    14,  -107,
    -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,    87,    90,
      91,    87,  -107,    87,    87,    92,    93,  -107,    87,  -107,
    -107
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
    -107,  -107,  -107,   120,  -107,  -107,  -107,  -107,  -107,  -107,
    -107,   126,  -107,    99,  -107,  -107,  -107,  -107,  -107,    97,
     -53,  -107,    29,   -32,  -106,    -7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
       1,    35,    36,    37,    38,   137,    30,    31,   137,   129,
     103,   130,   137,   116,   117,   104,    73,     7,     8,     9,
      10,    11,   105,   106,   107,   108,   109,   110,   111,   112,
       1,    12,    13,    14,    15,    16,   121,   122,   123,   124,
     116,   105,   106,   107,   108,   109,   110,   111,   112,   125,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,     7,     8,     9,    10,    11,   134,    35,    36,    37,
      38,   138,   129,     5,   130,    12,    13,    14,    15,    16,
     128,   133,     6,    26,    32,    27,    28,    29,    38,    33,
      46,    47,    48,    51,    49,    50,    76,    77,    78,    25,
     102,   115,   119,    80,   120,   116,   127,    34,    74,   139,
     140,    75,   126,     0,   135,   136
};

static const short yycheck[] =
{
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      24,    37,    38,    39,    40,   131,    49,    50,   134,    15,
      47,    17,   138,    46,    47,    52,    52,    41,    42,    43,
      44,    45,    25,    26,    27,    28,    29,    30,    31,    32,
      24,    55,    56,    57,    58,    59,   109,   110,   111,   112,
      46,    25,    26,    27,    28,    29,    30,    31,    32,    52,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    41,    42,    43,    44,    45,   128,    37,    38,    39,
      40,   133,    15,    47,    17,    55,    56,    57,    58,    59,
     117,   118,     0,    51,    48,    47,    47,    47,    40,    48,
      47,    47,    47,    51,    48,    48,    47,    47,    47,     3,
      47,    47,    47,    51,    48,    46,    48,    17,    39,    47,
      47,    44,   113,    -1,    54,    54
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    24,    61,    70,    71,    47,     0,    41,    42,    43,
      44,    45,    55,    56,    57,    58,    59,    62,    63,    64,
      65,    66,    67,    68,    69,    71,    51,    47,    47,    47,
      49,    50,    48,    48,    63,    37,    38,    39,    40,    72,
      73,    74,    75,    77,    78,    79,    47,    47,    47,    48,
      48,    51,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    52,    73,    79,    47,    47,    47,    76,
      51,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    47,    47,    52,    25,    26,    27,    28,    29,
      30,    31,    32,    81,    82,    47,    46,    47,    85,    47,
      48,    80,    80,    80,    80,    52,    82,    48,    85,    15,
      17,    83,    84,    85,    83,    54,    54,    84,    83,    47,
      47
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval = NULL;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 11:
#line 164 "parse.y"
    { 
    _warnmsg("'begin nodes' no longer needed"); 
;}
    break;

  case 12:
#line 166 "parse.y"
    { 
    _warnmsg("'end nodes' no longer needed"); 
;}
    break;

  case 13:
#line 168 "parse.y"
    { 
    _warnmsg("'begin global' no longer needed"); 
;}
    break;

  case 14:
#line 170 "parse.y"
    { 
    _warnmsg("'end global' no longer needed"); 
;}
    break;

  case 15:
#line 174 "parse.y"
    { 
    _warnmsg("'tcpwrappers' without yes|no"); 
    conf_set_use_tcp_wrappers(TRUE);
;}
    break;

  case 16:
#line 177 "parse.y"
    { 
    conf_set_use_tcp_wrappers(TRUE);
;}
    break;

  case 17:
#line 179 "parse.y"
    { 
    conf_set_use_tcp_wrappers(FALSE);
;}
    break;

  case 18:
#line 183 "parse.y"
    {
    makeClientPort(yyvsp[0]);
;}
    break;

  case 19:
#line 185 "parse.y"
    {
    _warnmsg("'client listener' not needed");
    makeClientPort(yyvsp[0]);
;}
    break;

  case 20:
#line 191 "parse.y"
    {
    makeDevice(yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
;}
    break;

  case 21:
#line 193 "parse.y"
    {
    makeDevice(yyvsp[-2], yyvsp[-1], yyvsp[0], NULL);
;}
    break;

  case 22:
#line 197 "parse.y"
    {
    makeNode(yyvsp[-2], yyvsp[-1], yyvsp[0]);
;}
    break;

  case 23:
#line 199 "parse.y"
    {
    makeNode(yyvsp[-1], yyvsp[0], NULL);
;}
    break;

  case 24:
#line 203 "parse.y"
    {
    makeAlias(yyvsp[-1], yyvsp[0]);
;}
    break;

  case 27:
#line 215 "parse.y"
    {
    makeSpec(yyvsp[-3]);
;}
    break;

  case 34:
#line 227 "parse.y"
    {
    _doubletotv(&current_spec.timeout, _strtodouble(yyvsp[0]));
;}
    break;

  case 35:
#line 231 "parse.y"
    {
    _doubletotv(&current_spec.ping_period, _strtodouble(yyvsp[0]));
;}
    break;

  case 36:
#line 235 "parse.y"
    {
    list_append((List)yyvsp[-1], Strdup(yyvsp[0])); 
    yyval = yyvsp[-1]; 
;}
    break;

  case 37:
#line 238 "parse.y"
    {
    yyval = (char *)list_create((ListDelF)Free);
    list_append((List)yyval, Strdup(yyvsp[0])); 
;}
    break;

  case 38:
#line 243 "parse.y"
    {
    if (current_spec.plugs != NULL)
        _errormsg("duplicate plug list");
    current_spec.plugs = (List)yyvsp[-1];
;}
    break;

  case 41:
#line 252 "parse.y"
    {
    makeScript(PM_LOG_IN, (List)yyvsp[0]);
;}
    break;

  case 42:
#line 254 "parse.y"
    {
    makeScript(PM_LOG_OUT, (List)yyvsp[0]);
;}
    break;

  case 43:
#line 256 "parse.y"
    {
    makeScript(PM_STATUS_PLUGS, (List)yyvsp[0]);
;}
    break;

  case 44:
#line 258 "parse.y"
    {
    makeScript(PM_STATUS_PLUGS_ALL, (List)yyvsp[0]);
;}
    break;

  case 45:
#line 260 "parse.y"
    {
    makeScript(PM_STATUS_NODES, (List)yyvsp[0]);
;}
    break;

  case 46:
#line 262 "parse.y"
    {
    makeScript(PM_STATUS_NODES_ALL, (List)yyvsp[0]);
;}
    break;

  case 47:
#line 264 "parse.y"
    {
    makeScript(PM_STATUS_TEMP, (List)yyvsp[0]);
;}
    break;

  case 48:
#line 266 "parse.y"
    {
    makeScript(PM_STATUS_TEMP_ALL, (List)yyvsp[0]);
;}
    break;

  case 49:
#line 268 "parse.y"
    {
    makeScript(PM_STATUS_BEACON, (List)yyvsp[0]);
;}
    break;

  case 50:
#line 270 "parse.y"
    {
    makeScript(PM_STATUS_BEACON_ALL, (List)yyvsp[0]);
;}
    break;

  case 51:
#line 272 "parse.y"
    {
    makeScript(PM_BEACON_ON, (List)yyvsp[0]);
;}
    break;

  case 52:
#line 274 "parse.y"
    {
    makeScript(PM_BEACON_OFF, (List)yyvsp[0]);
;}
    break;

  case 53:
#line 276 "parse.y"
    {
    makeScript(PM_POWER_ON, (List)yyvsp[0]);
;}
    break;

  case 54:
#line 278 "parse.y"
    {
    makeScript(PM_POWER_ON_ALL, (List)yyvsp[0]);
;}
    break;

  case 55:
#line 280 "parse.y"
    {
    makeScript(PM_POWER_OFF, (List)yyvsp[0]);
;}
    break;

  case 56:
#line 282 "parse.y"
    {
    makeScript(PM_POWER_OFF_ALL, (List)yyvsp[0]);
;}
    break;

  case 57:
#line 284 "parse.y"
    {
    makeScript(PM_POWER_CYCLE, (List)yyvsp[0]);
;}
    break;

  case 58:
#line 286 "parse.y"
    {
    makeScript(PM_POWER_CYCLE_ALL, (List)yyvsp[0]);
;}
    break;

  case 59:
#line 288 "parse.y"
    {
    makeScript(PM_RESET, (List)yyvsp[0]);
;}
    break;

  case 60:
#line 290 "parse.y"
    {
    makeScript(PM_RESET_ALL, (List)yyvsp[0]);
;}
    break;

  case 61:
#line 292 "parse.y"
    {
    makeScript(PM_PING, (List)yyvsp[0]);
;}
    break;

  case 62:
#line 296 "parse.y"
    {
    yyval = yyvsp[-1];
;}
    break;

  case 63:
#line 300 "parse.y"
    { 
    list_append((List)yyvsp[-1], yyvsp[0]); 
    yyval = yyvsp[-1]; 
;}
    break;

  case 64:
#line 303 "parse.y"
    { 
    yyval = (char *)list_create((ListDelF)destroyPreStmt);
    list_append((List)yyval, yyvsp[0]); 
;}
    break;

  case 65:
#line 308 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_EXPECT, yyvsp[0], NULL, NULL, NULL, NULL, NULL);
;}
    break;

  case 66:
#line 310 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_SEND, yyvsp[0], NULL, NULL, NULL, NULL, NULL);
;}
    break;

  case 67:
#line 312 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_DELAY, NULL, yyvsp[0], NULL, NULL, NULL, NULL);
;}
    break;

  case 68:
#line 314 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, yyvsp[-1], NULL, NULL, yyvsp[0], NULL, NULL);
;}
    break;

  case 69:
#line 316 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, yyvsp[-2], NULL, NULL, yyvsp[-1], NULL,
                             (List)yyvsp[0]);
;}
    break;

  case 70:
#line 319 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, NULL, NULL, yyvsp[-1], yyvsp[0], NULL, NULL);
;}
    break;

  case 71:
#line 321 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, NULL, NULL, yyvsp[-2], yyvsp[-1], NULL,(List)yyvsp[0]);
;}
    break;

  case 72:
#line 323 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, NULL, NULL, NULL, yyvsp[0], NULL, NULL);
;}
    break;

  case 73:
#line 325 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_SETPLUGSTATE, NULL, NULL, NULL,yyvsp[-1],NULL,(List)yyvsp[0]);
;}
    break;

  case 74:
#line 327 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_FOREACHNODE, NULL, NULL, NULL, NULL, 
                             (List)yyvsp[0], NULL);
;}
    break;

  case 75:
#line 330 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_FOREACHPLUG, NULL, NULL, NULL, NULL, 
                             (List)yyvsp[0], NULL);
;}
    break;

  case 76:
#line 333 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_IFOFF, NULL, NULL, NULL, NULL, 
                             (List)yyvsp[0], NULL);
;}
    break;

  case 77:
#line 336 "parse.y"
    {
    yyval = (char *)makePreStmt(STMT_IFON, NULL, NULL, NULL, NULL, 
                             (List)yyvsp[0], NULL);
;}
    break;

  case 78:
#line 341 "parse.y"
    { 
    list_append((List)yyvsp[-1], yyvsp[0]); 
    yyval = yyvsp[-1]; 
;}
    break;

  case 79:
#line 344 "parse.y"
    { 
    yyval = (char *)list_create((ListDelF)destroyInterp);
    list_append((List)yyval, yyvsp[0]); 
;}
    break;

  case 80:
#line 349 "parse.y"
    {
    yyval = (char *)makeInterp(ST_ON, yyvsp[0]);
;}
    break;

  case 81:
#line 351 "parse.y"
    {
    yyval = (char *)makeInterp(ST_OFF, yyvsp[0]);
;}
    break;

  case 82:
#line 355 "parse.y"
    {
    yyval = yyvsp[0];
;}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 1775 "parse_tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 359 "parse.y"


void scanner_init(char *filename);
void scanner_fini(void);
int scanner_line(void);
char *scanner_file(void);

/*
 * Entry point into the yacc/lex parser.
 */
int parse_config_file (char *filename)
{
    extern FILE *yyin; /* part of lexer */

    scanner_init(filename);

    yyin = fopen(filename, "r");
    if (!yyin)
        err_exit(TRUE, "%s", filename);

    device_specs = list_create((ListDelF) destroySpec);
    _clear_current_spec();

    yyparse();
    fclose(yyin);

    scanner_fini();

    list_destroy(device_specs);

    return 0;
} 

/* makePreStmt(type, str, tv, mp1(plug), mp2(stat/node), prestmts, interps */
static PreStmt *makePreStmt(StmtType type, char *str, char *tvstr, 
                      char *mp1str, char *mp2str, List prestmts, 
                      List interps)
{
    PreStmt *new;

    new = (PreStmt *) Malloc(sizeof(PreStmt));

    new->magic = PRESTMT_MAGIC;
    new->type = type;
    new->mp1 = mp1str ? _strtolong(mp1str) : -1;
    new->mp2 = mp2str ? _strtolong(mp2str) : -1;
    if (str)
        new->str = Strdup(str);
    if (tvstr)
        _doubletotv(&new->tv, _strtodouble(tvstr));
    new->prestmts = prestmts;
    new->interps = interps;

    return new;
}

static void destroyPreStmt(PreStmt *p)
{
    assert(p->magic == PRESTMT_MAGIC);
    p->magic = 0;
    if (p->str)
        Free(p->str);
    p->str = NULL;
    if (p->prestmts)
        list_destroy(p->prestmts);
    p->prestmts = NULL;
    if (p->interps)
        list_destroy(p->interps);
    p->interps = NULL;
    Free(p);
}

static void _clear_current_spec(void)
{
    int i;

    current_spec.name = NULL;
    current_spec.plugs = NULL;
    timerclear(&current_spec.timeout);
    timerclear(&current_spec.ping_period);
    for (i = 0; i < NUM_SCRIPTS; i++)
        current_spec.prescripts[i] = NULL;
}

static Spec *_copy_current_spec(void)
{
    Spec *new = (Spec *) Malloc(sizeof(Spec));
    int i;

    *new = current_spec;
    for (i = 0; i < NUM_SCRIPTS; i++)
        new->prescripts[i] = current_spec.prescripts[i];
    _clear_current_spec();
    return new;
}

static Spec *makeSpec(char *name)
{
    Spec *spec;

    current_spec.name = Strdup(name);

    /* FIXME: check for manditory scripts here?  what are they? */

    spec = _copy_current_spec();
    assert(device_specs != NULL);
    list_append(device_specs, spec);

    return spec;
}

static void destroySpec(Spec * spec)
{
    int i;

    if (spec->name)
        Free(spec->name);
    if (spec->plugs)
        list_destroy(spec->plugs);
    for (i = 0; i < NUM_SCRIPTS; i++)
        if (spec->prescripts[i])
            list_destroy(spec->prescripts[i]);
    Free(spec);
}

static int matchSpec(Spec * spec, void *key)
{
    return (strcmp(spec->name, (char *) key) == 0);
}

static Spec *findSpec(char *name)
{
    return list_find_first(device_specs, (ListFindF) matchSpec, name);
}

static void makeScript(int com, List stmts)
{
    if (current_spec.prescripts[com] != NULL)
        _errormsg("duplicate script");
    current_spec.prescripts[com] = stmts;
}

static Interp *makeInterp(InterpState state, char *str)
{
    Interp *new = (Interp *)Malloc(sizeof(Interp));

    new->magic = INTERP_MAGIC; 
    new->str = Strdup(str); 
    new->re = NULL;  /* defer compilation until copyInterpList */
    new->state = state;

    return new;
}

static void destroyInterp(Interp *i)
{
    assert(i->magic == INTERP_MAGIC);
    i->magic = 0;
    Free(i->str);
    if (i->re) {
        regfree(i->re);
        Free(i->re);
    }
    Free(i);
}

static List copyInterpList(List il)
{
    reg_syntax_t cflags = REG_EXTENDED | REG_NOSUB;
    ListIterator itr;
    Interp *ip, *icpy;
    List new = list_create((ListDelF) destroyInterp);

    if (il != NULL) {

        itr = list_iterator_create(il);
        while((ip = list_next(itr))) {
            assert(ip->magic == INTERP_MAGIC);
            icpy = makeInterp(ip->state, ip->str);
            icpy->re = (regex_t *)Malloc(sizeof(regex_t));
            Regcomp(icpy->re, icpy->str, cflags);
            assert(icpy->magic == INTERP_MAGIC);
            list_append(new, icpy);
        }
        list_iterator_destroy(itr);
    }

    return new;
}

/**
 ** Powerman.conf stuff.
 **/

static void destroyStmt(Stmt *stmt)
{
    assert(stmt != NULL);

    switch (stmt->type) {
    case STMT_SEND:
        Free(stmt->u.send.fmt);
        break;
    case STMT_EXPECT:
        regfree(&stmt->u.expect.exp);
        break;
    case STMT_DELAY:
        break;
    case STMT_SETPLUGSTATE:
        list_destroy(stmt->u.setplugstate.interps);
        break;
    case STMT_FOREACHNODE:
    case STMT_FOREACHPLUG:
    case STMT_IFON:
    case STMT_IFOFF:
        list_destroy(stmt->u.foreach.stmts);
        break;
    default:
        break;
    }
    Free(stmt);
}

static Stmt *makeStmt(PreStmt *p)
{
    Stmt *stmt;
    PreStmt *subp;
    reg_syntax_t cflags = REG_EXTENDED;
    ListIterator itr;

    assert(p->magic == PRESTMT_MAGIC);
    stmt = (Stmt *) Malloc(sizeof(Stmt));
    stmt->type = p->type;
    switch (p->type) {
    case STMT_SEND:
        stmt->u.send.fmt = Strdup(p->str);
        break;
    case STMT_EXPECT:
        Regcomp(&stmt->u.expect.exp, p->str, cflags);
        break;
    case STMT_SETPLUGSTATE:
        stmt->u.setplugstate.stat_mp = p->mp2;
        if (p->str)
            stmt->u.setplugstate.plug_name = Strdup(p->str);
        else
            stmt->u.setplugstate.plug_mp = p->mp1;
        stmt->u.setplugstate.interps = copyInterpList(p->interps);
        break;
    case STMT_DELAY:
        stmt->u.delay.tv = p->tv;
        break;
    case STMT_FOREACHNODE:
    case STMT_FOREACHPLUG:
        stmt->u.foreach.stmts = list_create((ListDelF) destroyStmt);
        itr = list_iterator_create(p->prestmts);
        while((subp = list_next(itr))) {
            assert(subp->magic == PRESTMT_MAGIC);
            list_append(stmt->u.foreach.stmts, makeStmt(subp));
        }
        list_iterator_destroy(itr);
        break;
    case STMT_IFON:
    case STMT_IFOFF:
        stmt->u.ifonoff.stmts = list_create((ListDelF) destroyStmt);
        itr = list_iterator_create(p->prestmts);
        while((subp = list_next(itr))) {
            assert(subp->magic == PRESTMT_MAGIC);
            list_append(stmt->u.ifonoff.stmts, makeStmt(subp));
        }
        list_iterator_destroy(itr);
        break;
    default:
        break;
    }
    return stmt;
}

static void _parse_hoststr(Device *dev, char *hoststr, char *flagstr)
{
    /* pipe device, e.g. "conman -j baytech0 |&" */
    if (strstr(hoststr, "|&") != NULL) {
        dev->data           = pipe_create(hoststr, flagstr);
        dev->destroy        = pipe_destroy;
        dev->connect        = pipe_connect;
        dev->disconnect     = pipe_disconnect;
        dev->finish_connect = NULL;
        dev->preprocess     = NULL;

    /* serial device, e.g. "/dev/ttyS0" */
    } else if (hoststr[0] == '/') {
        struct stat sb;

        if (stat(hoststr, &sb) == -1 || (!(sb.st_mode & S_IFCHR))) 
            _errormsg("serial device not found or not a char special file");

        dev->data           = serial_create(hoststr, flagstr);
        dev->destroy        = serial_destroy;
        dev->connect        = serial_connect;
        dev->disconnect     = serial_disconnect;
        dev->finish_connect = NULL;
        dev->preprocess     = NULL;

    /* tcp device, e.g. "cyclades0:2001" */
    } else {
        char *port = strchr(hoststr, ':');
        int n;

        if (port) {                 /* host='host:port', flags=NULL */
            *port++ = '\0';
        } else
            _errormsg("hostname is missing :port");

        n = _strtolong(port);       /* verify port number */
        if (n < 1 || n > 65535)
            _errormsg("port number out of range");
        dev->data           = tcp_create(hoststr, port, flagstr);
        dev->destroy        = tcp_destroy;
        dev->connect        = tcp_connect;
        dev->disconnect     = tcp_disconnect;
        dev->finish_connect = tcp_finish_connect;
        dev->preprocess     = tcp_preprocess;
    }
}

static void makeDevice(char *devstr, char *specstr, char *hoststr, 
                        char *flagstr)
{
    ListIterator itr;
    Device *dev;
    Spec *spec;
    int i;

    /* find that spec */
    spec = findSpec(specstr);
    if ( spec == NULL ) 
        _errormsg("device specification not found");

    /* make the Device */
    dev = dev_create(devstr);
    dev->specname = Strdup(specstr);
    dev->timeout = spec->timeout;
    dev->ping_period = spec->ping_period;

    _parse_hoststr(dev, hoststr, flagstr);

    /* create plugs (spec->plugs may be NULL) */
    dev->plugs = pluglist_create(spec->plugs);

    /* transfer remaining info from the spec to the device */
    for (i = 0; i < NUM_SCRIPTS; i++) {
        PreStmt *p;

        if (spec->prescripts[i] == NULL) {
            dev->scripts[i] = NULL;
            continue; /* unimplemented script */
        }

        dev->scripts[i] = list_create((ListDelF) destroyStmt);

        /* copy the list of statements in each script */
        itr = list_iterator_create(spec->prescripts[i]);
        while((p = list_next(itr))) {
            list_append(dev->scripts[i], makeStmt(p));
        }
        list_iterator_destroy(itr);
    }

    dev_add(dev);
}

static void makeAlias(char *namestr, char *hostsstr)
{
    if (!conf_add_alias(namestr, hostsstr))
        _errormsg("bad alias");
}

static void makeNode(char *nodestr, char *devstr, char *plugstr)
{
    Device *dev = dev_findbyname(devstr);

    if (dev == NULL) 
        _errormsg("unknown device");

    /* plugstr can be NULL - see comment in pluglist.h */
    switch (pluglist_map(dev->plugs, nodestr, plugstr)) {
        case EPL_DUPNODE:
            _errormsg("duplicate node");
        case EPL_UNKPLUG:
            _errormsg("unknown plug name");
        case EPL_DUPPLUG:
            _errormsg("plug already assigned");
        case EPL_NOPLUGS:
            _errormsg("more nodes than plugs");
        case EPL_NONODES:
            _errormsg("more plugs than nodes");
        default:
            break;
    }

    if (!conf_addnodes(nodestr))
        _errormsg("duplicate node name");
}

static void makeClientPort(char *s2)
{
    int port = _strtolong(s2);

    if (port < 1024)
        _errormsg("bogus client listener port");
    conf_set_listen_port(port); 
}

/**
 ** Utility functions
 **/

static double _strtodouble(char *str)
{
    char *endptr;
    double val = strtod(str, &endptr);

    if (val == 0.0 && endptr == str)
        _errormsg("error parsing double value");
    if ((val == HUGE_VAL || val == -HUGE_VAL) && errno == ERANGE)
        _errormsg("double value would cause overflow");
    return val;
}

static long _strtolong(char *str)
{
    char *endptr;
    long val = strtol(str, &endptr, 0);

    if (val == 0 && endptr == str)
        _errormsg("error parsing long integer value");
    if ((val == LONG_MIN || val == LONG_MAX) && errno == ERANGE)
        _errormsg("long integer value would cause under/overflow");
    return val;
}

static void _doubletotv(struct timeval *tv, double val)
{
    tv->tv_sec = (val * 10.0)/10; /* crude round-down without -lm */
    tv->tv_usec = ((val - tv->tv_sec) * 1000000.0);
}

static void _errormsg(char *msg)
{
    err_exit(FALSE, "%s: %s::%d", msg, scanner_file(), scanner_line());
}

static void _warnmsg(char *msg)
{
    err(FALSE, "warning: %s: %s::%d", msg, scanner_file(), scanner_line());
}

void yyerror()
{
    _errormsg("parse error");
}

/*
 * vi:tabstop=4 shiftwidth=4 expandtab
 */

